/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
// 鸿蒙应用bridge 适配
import './bridge'
import weex from './instance'
import * as core from '../core'

import { inputCommon } from '../mixins'

window.global = window
window.weex = weex

if (window.weex.config.env.platform === 'HarmonyOS') {
  // 鸿蒙app工程所处 web 环境，固定值适配
  if (window.weex.config.env.osName === 'harmonyOS') {
    // 页面加载完成后调用
    try {
      // 鸿蒙状态下获取statusBarHeight
      // eslint-disable-next-line no-undef
      LightJSBridge.call('native.getStatusBarHeight', {}, function (res) {
        if (res && res.data) {
          window.weex.config.env.statusBarHeight = res.data.height * weex.config.env.dpr
        }
        else {
          window.weex.config.env.statusBarHeight = 0
        }
      })
    }
    catch (e) {
      console.warn('当前环境不支持使用 LightJSBridge ')
    }
  }
}

weex._styleMap = {}

; ['getComponentInlineStyle',
  'extractComponentStyle',
  'mapNativeEvents',
  'trimTextVNodes']
  .forEach(function (method) {
    weex[method] = core[method].bind(weex)
  })

weex.mixins = {
  inputCommon
}
